--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

package body Nomo.Interpreter.Emission_Channels is

   protected body Emission_Channel is

      procedure Initialize (Action : in not null Callback) is
      begin
         pragma Assert (Output = null);
         Output := Action;
      end Initialize;

      procedure Put (Intensity : in Real_0_To_1;
                     Data      : in System.Address) is
      begin
         pragma Assert (Output /= null);
         Output.all (Intensity, Data);
      end Put;

   end Emission_Channel;

end Nomo.Interpreter.Emission_Channels;
